program FirstDer

! Take Second derivative of input file
! Only along the first axis

  use sep


implicit none



 
 integer    :: ix, iz, i3, nx, nz, n3
 real       :: nr
 real       :: dx, dz, d3, oz, ox, o3
 real, dimension(:), allocatable  ::  temp
 real, dimension(:,:,:), allocatable :: model

 call sep_init()





  ! Read back ground mmocity param
   call from_history("n1", nz);  call from_history("d1", dz);  call from_history("o1",oz);
   call from_history("n2", nx);  call from_history("d2", dx);  call from_history("o2",ox);
   call from_history("n3", n3,1); call from_history("d3", d3,1.);  call from_history("o3",o3,0.);



   allocate( model(nz,nx,n3), temp(nz))



   ! Read in the background mmocity
    call sep_read( model(1:nz,1:nx,1:n3))


if (1 == 1) then

   ! take 1st derivative of receiver wavefield
   do i3=1,n3     
     do ix=1,nx
      temp(:) = model(:,ix,i3)
       do iz=1,nz-1
         temp(iz) = (model(iz+1,ix,i3) - model(iz,ix,i3))
      end do
      model(:,ix,i3) = temp(:)
     end do
   end do
   
!   do iz=1,nz
!        tempV2(:) = vp(iz,:)
!      call FirstDer(.true.,tempV2, tempV2, nx, mm%x%d)
!      vp(iz,:) = tempV2(:)
!   end do


end if


   
!----------------------------------------------
! Output

  call sep_write(model,dim1=nz, dim2=nx, dim3=n3, esize=4)
  
  call to_history("n1",nz); call to_history("d1",dz);  call to_history("o1",oz);
  call to_history("n2",nx); call to_history("d2",dx);  call to_history("o2",ox);
  call to_history("n3",n3); call to_history("d3",d3);  call to_history("o3",o3);
  
  

end program
