program FirstDer1D

! Take First derivative of input file
! Only along the first axis

  use sep


implicit none



 
 integer    :: it, nt
 real       :: dt, ot
 real, dimension(:), allocatable  ::  temp
 real, dimension(:), allocatable :: model

 call sep_init()


  ! Read back ground mmocity param
   call from_history("n1", nt);  call from_history("d1", dt);  call from_history("o1",ot);

   allocate( model(nt), temp(nt))

   ! Read in the background mmocity
    call sep_read( model(1:nt))

   ! take 1st derivative of receiver wavefield
      temp(:) = model(:)
       do it=1,nt-1
         temp(it) = (model(it+1) - model(it))
      end do
      model(:) = temp(:)
   
!----------------------------------------------
! Output

  call sep_write(model, esize=4)
  
  call to_history("n1",nt); call to_history("d1",dt);  call to_history("o1",ot);
  
 
end program
